var participantOverview={};

participantOverview.init=
function(cb=null){
   let that=this;
   let action=function(){that.scriptsLoaded(cb);};
   LABKEY.Utils.requiresScript(["crf/crfSetup.js","crf/crfData.js","crf/crfHTML.js"],action);
}

participantOverview.scriptsLoaded=
function(cb=null){
   //if other script need init, just stack the init scripts
   //let action=function(){runQuery.init(cb);}
   crfData.setSetup(crfSetup);
   crfHTML.init();
   let initData=function(){crfData.init(cb);};
   crfSetup.init(initData);
}

participantOverview.print=
function(msg){
   console.log(msg);
}

participantOverview.addObjectToMap=
function(object,map,id){
   if (id in map){
      map[id].push(object);
      return;
   }
   map[id]=new Array();
   map[id].push(object);
}


participantOverview.generateParticipantArray=
function(){
   let fName='generateParticipantArray';
   this.print(fName);
   let that=this;
   let makeArray=function(){that.makeArray();};
   let setRegistration=function(){crfData.setRegistration(makeArray);};
   let action=function(){crfSetup.parseSetup(setRegistration);}
   crfSetup.setContainers(action);
}

participantOverview.matchRegistration=
function(entry){
   let fName='matchRegistration';
   let sF='participantStudyId';
   let studyRegMap=crfData.getRegistrationEntryMap(sF);//should be unique for registration
   let nS=Object.keys(studyRegMap).length;
   //this.print(fName+' study registration entries '+nS);
   let lF='participantLocalId';
   let localRegMap=crfData.getRegistrationEntryMap(lF);//should be unique for registration
   let nL=Object.keys(localRegMap).length;
   //this.print(fName+' local registration entries '+nL);
   if (entry[sF]){
      if (entry[sF] in studyRegMap){
         return studyRegMap[entry[sF]];
      }
      //failed to match study id
   }
   if (entry[lF]){
      if (entry[lF] in localRegMap){
         return localRegMap[entry[lF]];
      }
      //failed to match local id
   }
   return null;
}


participantOverview.makeArray=
function(){
   let fName='makeArray';
   let entries=crfSetup.getEntryMap('crfEntries'); 
   let n=Object.keys(entries).length;
   this.print(fName+' entries '+n);
   
   let idField='participantStudyId';
   let entryMap=new Object();

   let statusMap=crfSetup.getEntryMap('formStatusAll');
   let i=0;
   for (let key in entries){
      
      let entry=entries[key];

      let formStatus=statusMap[entry['FormStatus']]['formStatus'];
      if (formStatus=='Deleted'){
         continue;
      }

      let regEntry=this.matchRegistration(entry);
      if (regEntry){
         //link crfEntry to registration row
         let idLabel=crfSetup.getParticipantLabel(regEntry);
         this.addObjectToMap(entry,entryMap,idLabel);
      }
      else{
         let idLabel=crfSetup.getParticipantLabel(entry);
         this.print(fName+' ['+entry['Key']+'] no match found '+idLabel);
         i++;
      }
   }
   this.print('Found '+(n-i)+'/'+n+' participants');
}
